//address.hpp

   /*-----------------------------------------------------------------------*\
   | OWLSock For Windows v1.0                                                |
   --------------------------------------------------------------------------|
   | Written By:  Paul Pedriana                                              |
   | Date:        May 7, 1995.                                               |
   | Copyright:   Copyright (c) 1995 by Paul Pedriana.  All Rights Reserved. |
   | UserID(s):   70541,3223                                                 |
   |              70541.3223@compuserve.com                                  |
   --------------------------------------------------------------------------|
   | OWLSock is a Winsock C++ class library for OWL and Windows (16 and 32). |
   | It makes the use of Winsock much simpler and organizes Winsock's        |
   | functionality into logical classes.  See owlsock.doc and the owlsock    |
   | source files for documentation on how to use OWLSock.                   |
   \*-----------------------------------------------------------------------*/

#ifndef _ADDRESS_HPP
#define _ADDRESS_HPP

#include <winsock.h>

//-********************************************************************
//SocketAddress normally stores its data in network byte ordering, as opposed to host
//  byte ordering.
class SocketAddress : public sockaddr{
public:
   SocketAddress();
   SocketAddress(sockaddr& newSockaddr);
   SocketAddress(SocketAddress& newSocketAddress);
   SocketAddress(u_short nNewFamily, char* chData, short nDataLength);

   SocketAddress& operator =(const sockaddr& newSockaddr);
   friend int operator ==(const SocketAddress& address1, const SocketAddress& address2);

   u_short GetFamily(){return sa_family;}
   void SetFamily(u_short nNewFamily){sa_family = nNewFamily;}
   void SetAddress(u_short nNewFamily, const char* chData, short nDataLength);
};


class INetSocketAddress : public SocketAddress{
public:
   enum INetClass{ClassA, ClassB, ClassC, ClassUnknown};
   INetSocketAddress();
   INetSocketAddress(sockaddr& newSockaddr);
   INetSocketAddress(u_short nNewPort, u_long lNewAddress=INADDR_ANY, u_short nNewFamily = AF_INET);
   INetSocketAddress(u_short nNewPort, char* szNewAddress, u_short nNewFamily = AF_INET);

   INetSocketAddress& operator =(const sockaddr& newSockaddr);
   operator sockaddr_in() const {return *((sockaddr_in*)this);}

   INetClass GetClass();
   u_short GetPort();
   u_long GetNetworkAddress();
   u_long GetNetwork();
   u_long GetNetwork(u_long lSubnet){return GetNetworkAddress() & lSubnet;}
   u_long GetNode();
   u_long GetNode(u_long lSubnet){return GetNetworkAddress() & ~lSubnet;}
   void SetAddress(u_short nNewFamily, u_short nNewPort, u_long lNewAddress);
   void SetPort(u_short nPort);
   void SetNetworkAddress(u_long lAddress);
   void SetNetworkAddress(char* szAddressDottedDecimal);
   void SetFiller();
   static u_long ConvertAddress(char* szAddress);
   static char* ConvertAddress(u_long lAddress);
   static short IsAddressDottedDecimal(char* szAddress);
};

#endif //_ADDRESS_HPP



