//sockerr.hpp

   /*-----------------------------------------------------------------------*\
   | OWLSock For Windows v1.0                                                |
   --------------------------------------------------------------------------|
   | Written By:  Paul Pedriana                                              |
   | Date:        May 7, 1995.                                               |
   | Copyright:   Copyright (c) 1995 by Paul Pedriana.  All Rights Reserved. |
   | UserID(s):   70541,3223                                                 |
   |              70541.3223@compuserve.com                                  |
   --------------------------------------------------------------------------|
   | OWLSock is a Winsock C++ class library for OWL and Windows (16 and 32). |
   | It makes the use of Winsock much simpler and organizes Winsock's        |
   | functionality into logical classes.  See owlsock.doc and the owlsock    |
   | source files for documentation on how to use OWLSock.                   |
   \*-----------------------------------------------------------------------*/

#ifndef _SOCKERR_HPP
#define _SOCKERR_HPP

#include <owl\owlpch.h>
#pragma hdrstop

//Define or undefine this depending on whether you want to use resources for strings:
//#define B_USING_STRING_RESOURCES

//The index from which the errors start in resource file->  Res. base + nError = String Resource Index.
//If you don't define it, then it assumes a base of zero.
//#define N_STRING_RESOURCE_BASE 0

//-****************************************************************************
#define N_MAX_REASON_STRING 256
class SocketError{
protected:
    int   nError;
    int   nSizeToAllocate;  //Size to allocate for szString.  Usually bigger than szString so we can append to it.
    char* szString;
    void  GetErrorString();

public:
    SocketError(int nNewError=0, int nNewSizeToAllocate=128);
    virtual ~SocketError();
    SocketError& operator=(SocketError& newSocketError);
    friend int operator==(SocketError& socketError1, SocketError& socketError2);

    void  ISocketError(int nNewError);
    int   GetReasonValue();
    char* GetReasonString();
    char* CopyReasonString(char* szDestinationString);
    char* AppendError(char* szStringToAppendErrorTo, char* szDestination=NULL);  //default to our own string (NULL argument).
    char* AppendError(int nStringResourceToAppendErrorTo, char* szDestination=NULL);
};
#endif //_SOCKERR_HPP

